# Changelog

<!--
### ✨ Feature
### 🤏 Minor change
### 🎨 Interface
### 🐛 Bugfix
### 🔒 Security
### 🚀‍️ CI / CD
### 🔨 Internal / Developers
### 📚 Documentation

**💥 Breaking:**
**⚠️ Deprecation:**
-->


## 6.0.0 (Upcoming)

### ✨ Feature
- Add SonarQube integration for exercises (thanks to @joel.vonderwe)
- **CLI**: Add possibility for the user to delete an exercise if they've reached the limit of 2 exercises
- **CLI**: List exercises of a user (thanks to @bedran.sezer)
- **CLI**: List available assignments (thanks to @bedran.sezer)

### 🔨 Internal / Developers
- Major dependencies update


## 5.0.0 (2024-10-21)

### ✨ Feature
- Add possibility of self-host the solution


## 4.2.0 (2024-07-05)

### ✨ Feature
- Add support for tags on assignments and exercises


## 4.1.1 (2024-05-28)

### 🐛 Bugfix
- Remove node warning messages


## 4.1.0 (2024-05-28)

### ✨ Feature
- Add features related to corrige (commentary, commit a specific link / update, delete link)

### 🎨 Interface
- Ask for confirmation before creating an exercise that already exists


## 4.0.0 (Upcoming)

### ✨ Feature
- Add features related to corrige (commentary, commit specific link / update, delete link)
- **CLI**: Add some commands to generate files that will be used for terminal completion (bash, fish and zsh)
- **CLI**: Add `dojo upgrade` command that automatic upgrade the CLI to the latest version (or the latest dev version)

### 🎨 Interface
- **CLI**: Move from `session` command to `auth` (for retro-compatibility, `session` command is still available, but hidden)

### 🤏 Minor change
- **CLI**: Do not add spaces in directory name of repository's clone

### 🔨 Internal / Developers
- Move all gitlab API calls to GitBreaker library
- SonarQube integration
- Dependencies update
- **API**: Multi-process start is disabled when it is not executed in a production environment

### 🐛 Bugfix
- **API**: Fix no response when Authorization header is missing
- **API**: Fix get assignment by url with assignment containing spaces

### 📚 Documentation
- Migration from Wiki to static web site


## 3.5.0 (2024-02-26)

### ✨ Feature
- Link a commit of an exercise as a correction of an assignment


## 3.4.0 (2024-01-23)

### ✨ Feature
- Limit of 2 exercises by user

### 🔨 Internal / Developers
- **CLI**: Suffix package and binaries with version name

### 🐛 Bugfix
- **CLI CI/CD**: Fix deletion of packages on release


## 3.3.0 (2024-01-18)

### ✨ Feature
- **CLI**: Add a run command on assignment (to run the assignment as an exercise)
- **CLI**: Show an information message when a new version of the CLI is available (and not required)
- Add a new optional field on `results.json` file to provide some flexible informations display for the teaching staff

### 🎨 Interface
- **CLI**: Add a new level of verbose for exercise / assignment run command

### 🐛 Bugfix
- **CLI**: Fix an error when providing template for assignment creation
- **CLI**: Fix docker daemon detection error (thanks to @tom.andrivet)


## 3.2.0 (2024-12-19)

### ✨ Feature
- **AssignmentCheck**: Add linter for help improve the quality of the assignment (the linter will not throw errors but warnings)
- **CLI**: Add possibility to clone a repository at creation

### 🤏 Minor change
- **Exercices**: Set names of students in exercise name in alphabetical order

### 🐛 Bugfix
- **CLI**: Show a correct error message when the user is not logged into the Dojo server


## 3.1.0 (2023-12-06)

### 🔨 Internal / Developers
- **Typescript**: Add linter (ESLint)

### 📚 Documentation
- **API**: Routes documentation with Swagger

### 🐛 Bugfix
- **CLI**: Fix error messages when not logged in


## 3.0.0 (2023-11-03)

### ✨ Feature
- Login to Dojo app via Gitlab OAuth
- User access type management
  - **student**: default access type for new users
  - **teachingStaff**: student access + possibility of creating assignment
  - **admin**: teachingStaff access + access to user access management

### 📚 Documentation
- Wiki update for this new version


## 2.2.0 (2023-10-16)

### ✨ Feature
- `results.json` file is now optional (if the teaching staff don't want to provide test details)
  - The exercise will be considered as valid if the container exit code is 0
  - The `results.json` file will be construct / completed with the container exit code
  - The `volume` argument of `dojo_assignment.json` is now optional (if the teaching staff don't want to provide `results.json` file or other files)
- Pipeline for assignment validation. The pipeline will check if the assignment is valid (if the `dojo_assignment.json` file is valid and if all the required files are present)
- **CLI**: Assignment run command added (to run the assignment locally)
- **API**: Client version detection (if the client version is too old, the API will return an error)

### 🎨 Interface
- **CLI**: The gitlab token can be passed as secret user input in addition to the command line.

### 🔨 Internal / Developers
- Enhancement in pipelines by splitting them into several files
- **CLI**: Environment support added to CLI config file

### 📚 Documentation
- Wiki update for this new version


## 2.1.0 (2023-09-29)

### ✨ Feature
- Pipeline badge added to exercises
- Creation of Debian / Ubuntu deb packages

### 🎨 Interface
- **💥 Breaking:** Renamed `dojo.enonce` (or `dojo.assignment`) file to `dojo_assignment.json`

### 🔨 Internal / Developers
- Deploy Wiki on Gitlab (on push to `main`) from files of `Wiki` folder
- Migration from .env files stored in Gitlab Secure Files to usage of `dotenv-vault` (locally)

### 📚 Documentation
- Added Wiki base


## 2.0.0 (2023-09-15)

### ✨ Feature
- Added license: AGPLv3

### 🎨 Interface
- **💥 Breaking:** Renamed `enonce` to `assignment`
- **💥 Breaking:** Renamed `exercice` to `exercise`

### 🔨 Internal / Developers
- Auto release by pipeline
    - For vX.Y.Z branch create release and tag with `-dev` suffix
    - For main branch create definitive release and remove `-dev` releases


## 1.0.1 (2023-08-12)

### ✨ Feature
- 🎉 Initial release of the project
